Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/PrintStackTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/PrintStackTests.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Components/PrintStackTests.cs	(revision 15334)
@@ -17,4 +17,6 @@
 
     [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ComponentTest")]
     public void TestPushLong() {
       printStack.Push(100L);
@@ -24,4 +26,6 @@
 
     [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ComponentTest")]
     public void TestPushDouble() {
       printStack.Push(100.5D);
@@ -31,4 +35,6 @@
 
     [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ComponentTest")]
     public void TestAsStringsWithNewline() {
       printStack.Push(100.5D);
@@ -46,4 +52,6 @@
 
     [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ComponentTest")]
     public void TestAsStringsWithoutNewline() {
       printStack.Push(100.5D);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15334)
@@ -39,6 +39,14 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="dotMemory.Unit, Version=103.0.0.0, Culture=neutral, PublicKeyToken=1010a0d8d6380325, processorArchitecture=MSIL">
+      <HintPath>..\packages\JetBrains.dotMemoryUnit.2.3.20160517.113140\lib\dotMemory.Unit.dll</HintPath>
+      <Private>True</Private>
+    </Reference>
     <Reference Include="HeuristicLab.Algorithms.GeneticAlgorithm-3.3">
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Algorithms.GeneticAlgorithm-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Analysis-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -73,4 +81,8 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.ParallelEngine-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Parameters-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Parameters-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -104,4 +116,5 @@
   </Choose>
   <ItemGroup>
+    <Compile Include="Benchmark\GPTests.cs" />
     <Compile Include="Benchmark\RandomWalkTests.cs" />
     <Compile Include="Benchmark\SolutionTests.cs" />
@@ -147,5 +160,7 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup />
+  <ItemGroup>
+    <None Include="packages.config" />
+  </ItemGroup>
   <Choose>
     <When Condition="'$(VisualStudioVersion)' == '10.0' And '$(IsCodedUITest)' == 'True'">
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 15334)
@@ -19,4 +19,5 @@
     protected PushConfiguration configuration = new PushConfiguration {
       TopLevelPushCode = false,
+      FloatStringFormat = "R",
       ErcOptions = new ErcOptions {
         ErcProbability = 0.05,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/DeterministicTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/DeterministicTests.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/DeterministicTests.cs	(revision 15334)
@@ -44,5 +44,5 @@
       var currentAverageQuality1 = GetDoubleResult(ga1, "CurrentAverageQuality");
       var currentAverageQuality2 = GetDoubleResult(ga2, "CurrentAverageQuality");
-      Assert.AreEqual(currentAverageQuality1, currentAverageQuality2, 0.0001);
+      Assert.AreEqual(currentAverageQuality1, currentAverageQuality2, 0.01);
 
       var currentWorstQuality1 = GetDoubleResult(ga1, "CurrentWorstQuality");
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/IndividualMapperTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/IndividualMapperTests.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Problem/IndividualMapperTests.cs	(revision 15334)
@@ -11,6 +11,9 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Encoding;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Individual;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
   using HeuristicLab.Random;
@@ -53,5 +56,5 @@
       var random = new MersenneTwister();
       var config = new PushConfiguration {
-        ParenthesesCloseBiasLevel = 4
+        CloseBiasLevel = 4
       };
 
@@ -75,4 +78,27 @@
       Assert.AreEqual(vector.Length, program.TotalExpressionCount);
     }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("Individual")]
+    public void PlushToPushProgram() {
+      var plushGenome = new PlushVector();
+
+      plushGenome.Add(new PlushEntry { Instruction = new ExecDoTimesExpression(), Close = 0 });
+      plushGenome.Add(new PlushEntry { Instruction = new IntegerPushExpression(8), Close = 0 });
+      plushGenome.Add(new PlushEntry { Instruction = new IntegerPushExpression(11), Close = 3 });
+      plushGenome.Add(new PlushEntry { Instruction = new IntegerAddExpression(), Close = 3, Silent = true });
+      plushGenome.Add(new PlushEntry { Instruction = new ExecIfExpression(), Close = 1 });
+      plushGenome.Add(new PlushEntry { Instruction = new IntegerPushExpression(17), Close = 0 });
+      plushGenome.Add(new PlushEntry { Instruction = new BooleanPushExpression(false), Close = 0 });
+      plushGenome.Add(new PlushEntry { Instruction = new CodeQuoteExpression(), Close = 0 });
+      plushGenome.Add(new PlushEntry { Instruction = new FloatMultiplyExpression(), Close = 2 });
+      plushGenome.Add(new PlushEntry { Instruction = new ExecRotateExpression(), Close = 0 });
+      plushGenome.Add(new PlushEntry { Instruction = new FloatPushExpression(34.44), Close = 0 });
+
+      var expected = PushParser.ParseProgram("( EXEC.DO*TIMES ( 8 11 ) EXEC.IF ( ) ( 17 false CODE.QUOTE ( FLOAT.* ) ) EXEC.ROT ( 34.44 ) ( ) ( ) )");
+
+      Assert.AreEqual(expected, plushGenome.PushProgram);
+    }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Program.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Program.cs	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Program.cs	(revision 15334)
@@ -0,0 +1,176 @@
+﻿using System.Linq;
+using System.Text;
+
+namespace Push.Thesis {
+  using System.IO;
+  using System.Threading.Tasks;
+
+  using HeuristicLab.Algorithms.GeneticAlgorithm;
+  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.Optimization;
+  using HeuristicLab.ParallelEngine;
+  using HeuristicLab.Persistence.Default.Xml;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Analyzer;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Crossover;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Manipulator;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Selector;
+
+  class Program {
+    static void Main(string[] args) {
+      //BuildListOfInstructions();
+      GenerateRuns();
+      GenerateExperiments();
+      //GenerateExperimentWithAllProblems();
+    }
+
+    private static void GenerateExperimentWithAllProblems() {
+      var provider = new BenchmarkSuiteInstanceProvider();
+
+      var algs = provider
+        .GetDataDescriptors()
+        .AsParallel()
+        .Select(descriptor => new Run(GetAlgorithm((IBenchmarkSuiteDataDescriptor)descriptor)))
+        .ToList();
+
+      var experiment = new Experiment("Experiment Benchmark Suite");
+      experiment.Runs.AddRange(algs);
+
+      XmlGenerator.Serialize(experiment, @"C:\tmp\Plush - GA\Experiment Benchmark Suite.hl");
+    }
+
+    static void GenerateRuns() {
+      var provider = new BenchmarkSuiteInstanceProvider();
+      var descriptors = provider.GetDataDescriptors();
+
+      Parallel.ForEach(descriptors, descriptor => {
+        var benchmarkSuiteProblemDescriptor = (BenchmarkSuiteDataDescriptor)descriptor;
+        var alg = GetAlgorithm(benchmarkSuiteProblemDescriptor);
+
+        XmlGenerator.Serialize(alg, $@"C:\tmp\Plush - GA\Runs\{descriptor.Name}.hl");
+      });
+    }
+
+    static void GenerateExperiments() {
+      var provider = new BenchmarkSuiteInstanceProvider();
+      var descriptors = provider.GetDataDescriptors();
+
+      Parallel.ForEach(descriptors, descriptor => {
+        var benchmarkSuiteProblemDescriptor = (BenchmarkSuiteDataDescriptor)descriptor;
+        var alg = GetAlgorithm(benchmarkSuiteProblemDescriptor);
+        var experiment = GetExperiment(alg, 10);
+
+        XmlGenerator.Serialize(experiment, $@"C:\tmp\Plush - GA\Experiments\Experiment_{descriptor.Name}.hl");
+      });
+    }
+
+    static Experiment GetExperiment(IAlgorithm alg, int repeats) {
+      var experiment = new Experiment("Experiment: " + alg.Problem.Name);
+      experiment.Optimizers.Add(new BatchRun {
+        Optimizer = alg,
+        Repetitions = repeats
+      });
+
+      return experiment;
+    }
+
+    static IAlgorithm GetAlgorithm(IBenchmarkSuiteDataDescriptor descriptor) {
+      var ga = new GeneticAlgorithm();
+
+      var problemData = descriptor.CreateProblemData();
+      var pushProblem = new PlushPushBenchmarkSuiteProblem();
+
+      pushProblem.Load(problemData);
+      ga.Name = "GA " + pushProblem.Name;
+
+      ga.Problem = pushProblem;
+
+      var crossover = ga.CrossoverParameter.ValidValues.OfType<AlternationCrossover>().First();
+
+      switch (problemData.ProblemType) {
+        case ProblemType.NumberIO:
+        case ProblemType.SmallOrLarge:
+        case ProblemType.Median:
+        case ProblemType.Smallest:
+          crossover.AlignmentDeviation = 5;
+          break;
+
+        default:
+          crossover.AlignmentDeviation = 10;
+          break;
+      }
+
+      crossover.AlternationRate = 0.01;
+      ga.Crossover = crossover;
+
+      ga.Selector = ga.SelectorParameter.ValidValues.OfType<LexicaseSelector>().First();
+
+      var mutator = ga.MutatorParameter.ValidValues.OfType<UniformMutation>().First();
+      mutator.InstructionMutationProbability = 0.875;
+      mutator.CloseMutationProbability = 0.125;
+      mutator.CloseIncrementRate = 0.1;
+      ga.Mutator = mutator;
+
+      ga.MutationProbability.Value = 0.8;
+      ga.SetSeedRandomly.Value = true;
+      ga.PopulationSize.Value = 1000;
+
+      ga.MaximumGenerations.Value = problemData.ProgramExecutionBudget / problemData.TrainingCount / 1000;
+
+      var zeroErrorAnalyzer = pushProblem.OperatorsParameter.Value
+        .OfType<IndividualZeroErrorAnalyzer>().SingleOrDefault();
+
+      if (zeroErrorAnalyzer != null) {
+        zeroErrorAnalyzer.StoreHistoryParameter.Value.Value = true;
+        zeroErrorAnalyzer.UpdateIntervalParameter.Value.Value = 5;
+      }
+
+      ga.Engine = new ParallelEngine();
+
+      return ga;
+    }
+
+    static void BuildListOfInstructions() {
+      var sb = new StringBuilder();
+      var attributes = ExpressionTable.StatelessExpressionTable.Values.Select(e => {
+        var type = e.GetType();
+        var attribute = ExpressionTable.TypeToAttributeTable[type];
+
+        return attribute;
+      }).ToList();
+
+      var attributesGrouped = attributes.GroupBy(a => a.StackType).OrderBy(g => g.Key.ToString());
+
+      foreach (var entry in attributesGrouped) {
+        sb.AppendLine($"\\textbf{{{entry.Key}}}");
+        sb.AppendLine("\\begin{description}");
+
+        foreach (var attribute in entry) {
+          var name = attribute.Name
+            .Replace("_", "\\_")
+            .Replace("%", "\\%");
+
+          sb.AppendLine($"\\item[{{{name}}}] {attribute.Description}");
+
+          if (attribute.RequiredBlockCount > 0)
+            sb.AppendLine($"\\\\block wants: {attribute.RequiredBlockCount}");
+
+          if (attribute.AdditionalStackDependencies != default(HeuristicLab.Problems.ProgramSynthesis.Push.Stack.StackTypes)) {
+            var dependenciesNames = attribute.AdditionalStackDependencies.ToValues().Select(v => v.ToString()).OrderBy(x => x);
+            var dependenciesStr = string.Join(", ", dependenciesNames);
+
+            sb.AppendLine($"\\\\dependencies: {dependenciesStr}");
+          }
+
+        }
+
+        sb.AppendLine("\\end{description}");
+      }
+
+
+      File.WriteAllText(@"T:\BTSync\projects\git\bitbucket\master\Paper\appendix\instructions.tex", sb.ToString());
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Properties/AssemblyInfo.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Properties/AssemblyInfo.cs	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Properties/AssemblyInfo.cs	(revision 15334)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("Push.Thesis")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("Push.Thesis")]
+[assembly: AssemblyCopyright("Copyright ©  2017")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("662c6679-3ee0-432f-a8a6-251ca165d30b")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Push.Thesis.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Push.Thesis.csproj	(revision 15334)
+++ /branches/PushGP/HeuristicLab.PushGP/Push.Thesis/Push.Thesis.csproj	(revision 15334)
@@ -0,0 +1,118 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{662C6679-3EE0-432F-A8A6-251CA165D30B}</ProjectGuid>
+    <OutputType>Exe</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>Push.Thesis</RootNamespace>
+    <AssemblyName>Push.Thesis</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <AutoGenerateBindingRedirects>true</AutoGenerateBindingRedirects>
+    <TargetFrameworkProfile />
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Algorithms.GeneticAlgorithm-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Algorithms.GeneticAlgorithm-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Analysis-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Collections-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Encodings.IntegerVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec" />
+    <Reference Include="HeuristicLab.Operators-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Operators-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Optimization-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.ParallelEngine-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.ParallelEngine-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Parameters-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Parameters-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Persistence-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Selection-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec" />
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Program.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="App.config" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite\HeuristicLab.BenchmarkSuite.csproj">
+      <Project>{22B5C087-CFC7-4D40-86C6-32FCF2CA921E}</Project>
+      <Name>HeuristicLab.BenchmarkSuite</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.ProgramSynthesis\HeuristicLab.Problems.ProgramSynthesis.csproj">
+      <Project>{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}</Project>
+      <Name>HeuristicLab.Problems.ProgramSynthesis</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/PushGP/HeuristicLab.PushGP/PushGp.sln
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/PushGp.sln	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/PushGp.sln	(revision 15334)
@@ -15,4 +15,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ProgramSynthesis.Base", "HeuristicLab.Problems.ProgramSynthesis.Base\HeuristicLab.Problems.ProgramSynthesis.Base.csproj", "{0A60B6BA-8ACE-478E-98F3-57441B53B5F9}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "Push.Thesis", "Push.Thesis\Push.Thesis.csproj", "{662C6679-3EE0-432F-A8A6-251CA165D30B}"
 EndProject
 Global
@@ -46,4 +48,8 @@
 		{0A60B6BA-8ACE-478E-98F3-57441B53B5F9}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{0A60B6BA-8ACE-478E-98F3-57441B53B5F9}.Release|Any CPU.Build.0 = Release|Any CPU
+		{662C6679-3EE0-432F-A8A6-251CA165D30B}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{662C6679-3EE0-432F-A8A6-251CA165D30B}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{662C6679-3EE0-432F-A8A6-251CA165D30B}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{662C6679-3EE0-432F-A8A6-251CA165D30B}.Release|Any CPU.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
